#### Linux From Scratch - Version 12.3-systemd

### Chapter 8. Installing Basic System Software

- Prev

  Libelf from Elfutils-0.192

- Next

  Python-3.13.2

- Up
- Home

# 8.50. Libffi-3.4.7

The Libffi library provides a portable, high level programming interface to various calling conventions. This allows a programmer to call any function specified by a call interface description at run time.

FFI stands for Foreign Function Interface. An FFI allows a program written in one language to call a program written in another language. Specifically, Libffi can provide a bridge between an interpreter like Perl, or Python, and shared library subroutines written in C, or C++.

Approximate build time: 1.7 SBU
Required disk space: 11 MB

## 8.50.1. Installation of Libffi

### Note

Like GMP, Libffi builds with optimizations specific to the processor in use. If building for another system, change the value of the `--with-gcc-arch=` parameter in the following command to an architecture name fully implemented by the CPU on that system. If this is not done, all applications that link to `libffi` will trigger Illegal Operation Errors.

Prepare Libffi for compilation:

    ./configure --prefix=/usr          \
                --disable-static       \
                --with-gcc-arch=native

The meaning of the configure option:

`--with-gcc-arch=native`

  Ensure GCC optimizes for the current system. If this is not specified, the system is guessed and the code generated may not be correct. If the generated code will be copied from the native system to a less capable system, use the less capable system as a parameter. For details about alternative system types, see the x86 options in the GCC manual.

Compile the package:

    make

To test the results, issue:

    make check

Install the package:

    make install

## 8.50.2. Contents of Libffi

Installed library: libffi.so

### Short Descriptions

`libffi` | Contains the foreign function interface API functions

- Prev

  Libelf from Elfutils-0.192

- Next

  Python-3.13.2

- Up
- Home